package com.s_cradle.improve.client;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import java.io.DataInputStream;
import java.io.IOException;

import com.s_cradle.improve.Constants;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * FB({l܂)\NXłB
 *
 * @author Masaru Yoshimura
 */
public class Buddy {
    // {lFB
    public static final int ATTRIBUTE_HIM    = 0;
    public static final int ATTRIBUTE_FRIEND = 1;

    // F萔
    private static final int COLOR_COLUMN_SELECT       = (102<<16) |  (51<<8) | 255;
    private static final int COLOR_STRING_SELECT_OTHER = (255<<16) | (255<<8) | 255;
    private static final int COLOR_STRING_NORMAL_OTHER =   (0<<16) |   (0<<8) |   0;
    private static final int COLOR_STRING_SELECT_HIM   = (255<<16) |   (0<<8) |   0;
    private static final int COLOR_STRING_NORMAL_HIM   = (255<<16) |   (0<<8) |   0;

    // `p̎X̒萔
    private static final int IMAGE_CIRCLE_WIDTH  = 14;
    private static final int IMAGE_CIRCLE_HEIGHT = 14;
    private static final int IMAGE_CIRCLE_RIGHT_INTERVAL = 11;
    private static final int COLUMN_HEIGHT = 18;

    private static final int STRING_LEFT_INTERVAL = 6;
    private static final int STRING_LEFT_INTERVAL_ARROW = 12;
    private static final int HEIGHT_MARGIN = 3;

    private static final int IMAGE_ARROW_HORIZONTAL_WIDTH  = 4;
    private static final int IMAGE_ARROW_HORIZONTAL_HEIGHT = 7;
    private static final int IMAGE_ARROW_HORIZONTAL_RIGHT_INTERVAL = 4;
    private static final int IMAGE_ARROW_HORIZONTAL_LEFT_INTERVAL  = 4;

    private static final int TICKER_HEIGHT = 18;

    // ̉摜
    private static final Image rightImage
        = ResourceManager.getImage(ResourceManager.IMAGE_RIGHT);
    private static final Image leftImage
        = ResourceManager.getImage(ResourceManager.IMAGE_LEFT);

    private String account;
    private String nickname;
    private int status;
    private String description;
    private int attribute;
    private String phoneNumber;
    private MessageBox messageBox;

    /**
     * 񂩂̃RXgN^B
     */
    public Buddy(String account_, String nickname_, int status_,
                 String description_, int attribute_, String phoneNumber_) {
        account = account_;
        nickname = nickname_;
        status = status_;
        description = description_;
        attribute = attribute_;
        phoneNumber = phoneNumber_;
    }

    /**
     * DataInputStream̃RXgN^B
     */
    public Buddy(DataInputStream input) throws IOException {
        account = input.readUTF();
        nickname = input.readUTF();
        phoneNumber = input.readUTF();
        status = input.readInt();
        description = input.readUTF();
        attribute = ATTRIBUTE_FRIEND;
    }

    // setter,getter
    public void setAccount(String account_){
        account = account_;
    }

    public String getAccount(){
        return account;
    }

    public void setNickname(String nickname_){
        nickname = nickname_;
    }

    public String getNickname(){
        return nickname;
    }

    public void setStatus(int status_){
        status = status_;
    }

    public int getStatus(){
        return status;
    }

    public void setDescription(String description_){
        description = description_;
    }

    public String getDescription(){
        return description;
    }

    public void setAttribute(int attribute_){
        attribute = attribute_;
    }

    public int getAttribute(){
        return attribute;
    }

    public void setPhoneNumber(String phoneNumber_){
        phoneNumber = phoneNumber_;
    }

    public String getPhoneNumber(){
        return phoneNumber;
    }

    public void setMessageBox(MessageBox messageBox_){
        messageBox = messageBox_;
    }

    public MessageBox getMessageBox(){
        return messageBox;
    }
    // setter,getter܂

    /**
     * equals ̒`BAJEgȂ trueB
     */
    public boolean equals(Object obj){
        if( obj instanceof Buddy ){
            return account.equals(((Buddy)obj).getAccount());
        } else{
            return false;
        }
    }

    /**
     * BuddyIuWFNgœeXVB
     */
    public void update(Buddy buddy){
        setNickname(buddy.getNickname());
        setPhoneNumber(buddy.getPhoneNumber());
        setDescription(buddy.getDescription());
        setStatus(buddy.getStatus());
    }

    /**
     * I󋵂ɉ摜̎擾B
     */
    public Image getImage(boolean select){
        Image image;
        switch( status ){
            case Constants.STATUS_BLUE:
                image = ResourceManager.getImage(
                        (select) ? ResourceManager.IMAGE_SELECT_GREEN :
                        ResourceManager.IMAGE_NORMAL_GREEN);
                break;
            case Constants.STATUS_YELLOW:
                image = ResourceManager.getImage(
                        (select) ? ResourceManager.IMAGE_SELECT_YELLOW :
                        ResourceManager.IMAGE_NORMAL_YELLOW);
                break;
            case Constants.STATUS_RED:
                image = ResourceManager.getImage(
                        (select) ? ResourceManager.IMAGE_SELECT_RED :
                        ResourceManager.IMAGE_NORMAL_RED);
                break;
            //case STATUS_LOGOFF:
            default:
                image = ResourceManager.getImage(
                (select) ? ResourceManager.IMAGE_SELECT_OFF :
                ResourceManager.IMAGE_NORMAL_OFF);
                break;
        }

        return image;
    }

    /**
     * OEtH[JXEACR̕`
     */
    public void draw(Graphics g, int width, int positionY, boolean focus, boolean left){
        int color, stringColor;
        Image image = getImage(focus);

        switch( attribute ){
            case ATTRIBUTE_HIM:
                stringColor = (focus) ? COLOR_STRING_SELECT_HIM : COLOR_STRING_NORMAL_HIM;
                break;
            //case ATTRIBUTE_FRIEND:
            default:
                stringColor = (focus) ? COLOR_STRING_SELECT_OTHER : COLOR_STRING_NORMAL_OTHER;
                break;
        }

        if( focus ){
            g.setColor(COLOR_COLUMN_SELECT);
            g.fillRect(1, positionY+1, width-2, COLUMN_HEIGHT-2);
        }
        if( left ){
            g.drawImage(leftImage,IMAGE_ARROW_HORIZONTAL_LEFT_INTERVAL,
                        positionY+(COLUMN_HEIGHT-IMAGE_ARROW_HORIZONTAL_HEIGHT)/2,
                        Graphics.LEFT | Graphics.TOP);
        } else if( messageBox != null ){
            g.drawImage(rightImage,width-IMAGE_ARROW_HORIZONTAL_WIDTH-
                            IMAGE_ARROW_HORIZONTAL_RIGHT_INTERVAL,
                        positionY+(COLUMN_HEIGHT-IMAGE_ARROW_HORIZONTAL_HEIGHT)/2,
                        Graphics.LEFT | Graphics.TOP);
        }
        g.setColor(stringColor);
        g.drawString(nickname,
                     (left) ? STRING_LEFT_INTERVAL_ARROW : STRING_LEFT_INTERVAL,
                     positionY+HEIGHT_MARGIN, Graphics.LEFT | Graphics.TOP);
        g.drawImage(image,width-IMAGE_CIRCLE_WIDTH-IMAGE_CIRCLE_RIGHT_INTERVAL,
                    positionY+(COLUMN_HEIGHT-IMAGE_CIRCLE_HEIGHT)/2,
                    Graphics.LEFT | Graphics.TOP);
    }
}
