package com.s_cradle.improve.client;

import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Canvas;
import java.util.Enumeration;
import java.util.Hashtable;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * FBXg\ Menu łB
 *
 * @author Masaru Yoshimura
 */
public class BuddyListMenu extends Menu {
    /** `p萔 */
    private static final int TICKER_HEIGHT = 18;
    private static final int IMAGES_INTERVAL = 30;

    private static final int IMAGE_ARROW_VERTICAL_WIDTH = 7;
    private static final int IMAGE_ARROW_VERTICAL_HEIGHT = 4;
    private static final int IMAGE_ARROW_VERTICAL_IMAGES_INTERVAL = 8;
    private static final int IMAGE_ARROW_VERTICAL_DOWN_INTERVAL = 4;

    /** qj[ */
    private Menu menu;

    /** tH[JXĂBuddy*/
    private Buddy cursorBuddy;

    private int delta;
    private int field;

    /**
     * RXgN^
     */
    public BuddyListMenu() {
        super(null,null);
        delta = 0;
    }

    /**
     * `
     */
    public void draw(Graphics g, int width_, int height_){
        g.translate(0, TICKER_HEIGHT+1);
        draw3DRect(g, 0, 0, width_, height_-g.getTranslateY(),
                   ImproveAbstractCanvas.LIST_BG_COLOR, 0x00EEEEFF, 0x00000080);

        field = (height_-g.getTranslateY())/18;

        if(cursor - delta < 0){
            delta = cursor;
        }
        if(cursor-delta >= field){
            delta = cursor-field+1;
        }
        if(cursor >= ImproveMIDlet.buddyList.size()){
            cursor = ImproveMIDlet.buddyList.size()-1;
            if(cursor < 0){
                cursor = 0;
            }
        }

        boolean up = (delta>0);
        boolean down = (ImproveMIDlet.buddyList.size()-delta-field > 0);

        int temp=0,position=0;
        for(Enumeration e=ImproveMIDlet.buddyList.elements();e.hasMoreElements();){
            Buddy buddy = (Buddy)e.nextElement();
            if( temp < delta ){
                temp++;
            } else{
                buddy.draw(g,width_,COLUMN_HEIGHT*position,((position+delta)==cursor),false);
                if((position+delta) == cursor){
                    cursorBuddy = buddy;
                }
                position++;
                if( COLUMN_HEIGHT*(position+1) + ((up || down) ?
                        IMAGE_ARROW_VERTICAL_HEIGHT+
                        IMAGE_ARROW_VERTICAL_DOWN_INTERVAL : 0) >
                        height_-g.getTranslateY()){
                    position--;
                    break;
                }
            }
        }
        if( up ){
            g.drawImage(ResourceManager.getImage(ResourceManager.IMAGE_UP),
                        (width_-IMAGE_ARROW_VERTICAL_WIDTH*2-IMAGE_ARROW_VERTICAL_IMAGES_INTERVAL)/2,
                        height_-g.getTranslateY()-IMAGE_ARROW_VERTICAL_HEIGHT-IMAGE_ARROW_VERTICAL_DOWN_INTERVAL,
                        g.TOP | g.LEFT);
        }
        if( down ){
            g.drawImage(ResourceManager.getImage(ResourceManager.IMAGE_DOWN),
                        (width_+IMAGE_ARROW_VERTICAL_IMAGES_INTERVAL)/2,
                        height_-g.getTranslateY()-IMAGE_ARROW_VERTICAL_HEIGHT-IMAGE_ARROW_VERTICAL_DOWN_INTERVAL,
                        g.TOP | g.LEFT);
        }

        g.translate(0, -(TICKER_HEIGHT+1));

        if(menu != null){
            menu.draw(g,width_,height_);
        }
    }


    /**
     * L[nh
     */
    protected Menu processFireKeyRelease() {
        if(cursorBuddy != null){
            if( cursorBuddy.getAttribute() == Buddy.ATTRIBUTE_HIM ){
                return new MainMenu(cursorBuddy);
            } else{
                return new FriendMenu(cursorBuddy);
            }
        } else{
            System.out.println("error in BuddyListMenu.processFireKeyRelease!");
            return null;
        }
    }

    /**
     * L[nh
     */
    public Menu processKeyRelease(int gameAction, int keyCode){
        if( menu != null ){
            menu = menu.processKeyRelease(gameAction,keyCode);
        } else{
            switch( gameAction ){
                case Canvas.FIRE:
                    menu =  processFireKeyRelease();
                    break;
                case Canvas.DOWN:
                    if( cursor+1 < ImproveMIDlet.buddyList.size() ){
                        cursor++;
                        cursorBuddy = null;
                    }
                    break;
                case Canvas.UP:
                    if( cursor > 0 ){
                        cursor--;
                        cursorBuddy = null;
                    }
                    break;
                case Canvas.RIGHT:
                    if( cursorBuddy != null && cursorBuddy.getMessageBox() != null ){
                        ImproveMIDlet.setCurrent(new MessagingCanvas(cursorBuddy));
                        return null;
                    }
                    break;
                default:
                    break;
            }
        }

        return this;
    }
}
