package com.s_cradle.improve.client;

import java.io.*;
import com.s_cradle.improve.Constants;
import javax.microedition.lcdui.Alert;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * |[Oɑ^XNsNXłB
 * Iy[Vadd, remove, set, send𔭍s܂B
 *
 * @author Masaru Yoshimura
 */
public class FollowedByPollingTask extends Task {
    private static final String SET_STATUS = String.valueOf(Constants.ITEM_INDEX_STATUS);
    private static final String STATUS_LOGOFF = String.valueOf(Constants.STATUS_LOGOFF);

    private static final String TYPE_MESSAGE = String.valueOf(Constants.MESSAGE_TYPE_NORMAL);
    private static final String WARNING_CONNECT_MESSAGE = "O̒ʐMs܂B";
    private static final String WARNING_SERVER_MESSAGE = "ނװԂ܂B";
    private static final String[][] ITEMS = new String[][]{
        new String[]{
        Constants.PARAMETER_ACCOUNT,Constants.PARAMETER_PASSWORD,
        Constants.PARAMETER_TARGET
        },
        new String[]{
        Constants.PARAMETER_ACCOUNT,Constants.PARAMETER_PASSWORD,
        Constants.PARAMETER_TARGET
        },
        new String[]{
        Constants.PARAMETER_ACCOUNT,
        Constants.PARAMETER_PASSWORD,
        Constants.PARAMETER_ITEM,
        Constants.PARAMETER_CONTENT
        },
        new String[]{
        Constants.PARAMETER_ACCOUNT,
        Constants.PARAMETER_PASSWORD,
        Constants.PARAMETER_TARGET,
        Constants. PARAMETER_TYPE,
        Constants.PARAMETER_CONTENT
        },
    };

    public static final int FBPT_ADD = 0;
    public static final int FBPT_REMOVE = 1;
    public static final int FBPT_SET = 2;
    public static final int FBPT_SEND = 3;

    private static final int[] TASK = new int[]{
        TASK_ADD,TASK_REMOVE,TASK_SET,TASK_SEND
    };

    /**
     * RXgN^Bꂼ̃Iy[V̒lɂƂ܂B
     */
    public FollowedByPollingTask(int task, String[] strs) {
        this.parameterNames = ITEMS[task];
        this.task = TASK[task];
        switch(task){
            case FBPT_ADD:
            case FBPT_REMOVE:
                if( strs.length == 1 ){
                    this.parameterValues = new String[]{account,password,strs[0]};
                }
                break;
            case FBPT_SET:
                if( strs.length == 2 ){
                    this.parameterValues = new String[]{account,password,strs[0],
                        strs[1]};
                }
                break;
            case FBPT_SEND:
                if( strs.length == 3 ){
                    this.parameterValues = new String[]{account,password,strs[0],
                        strs[1],strs[2]};
                }
                break;
        }
        if(this.parameterNames == null){
            throw new IllegalArgumentException("number of argument names and values not match!");
        }

        status = STATUS_NOT_YET;
    }

    /**
     * s̏
     */
    protected void processFailed() {
        System.out.println("f");
        Alert alert = new Alert(WARNING_SERVER_MESSAGE);
        alert.setTimeout(Alert.FOREVER);
        ImproveMIDlet.setCurrent(alert, ImproveMIDlet.getCurrent());
    }

    /**
     * Throwableꂽ̏
     */
    protected void processThrowable(){
        System.out.println("t");
        Alert alert = new Alert(WARNING_CONNECT_MESSAGE);
        alert.setTimeout(Alert.FOREVER);
        ImproveMIDlet.setCurrent(alert, ImproveMIDlet.getCurrent());
    }

    /**
     * Ԓlǂ񂾌̏
     */
    protected void processAfterReturnValue(int result, DataInputStream input)
            throws java.io.IOException {
        if( task == TASK_SET && parameterValues[2].equals(SET_STATUS)
            && parameterValues[3].equals(STATUS_LOGOFF) ){
            ImproveMIDlet.midlet.notifyDestroyed();
        }

        Task t = Task.getTask(Task.TASK_POLLING,null);
        if( task == TASK_SEND ){
            PollingTask pt = (PollingTask)t;
            pt.addOwnMessage(parameterValues[2],parameterValues[4]);
        }
        t.schedule(0);
    }
}