package com.s_cradle.improve.client;

import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.StringItem;
import javax.microedition.lcdui.ImageItem;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.Displayable;
import com.s_cradle.improve.Constants;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * FBtH[JX Menu łBB
 *
 * @author Masaru Yoshimura
 */
public class FriendMenu extends Menu implements CommandListener{
    private static final String PRE_TITLE = "ƭ:";
    private static final String[] ITEMS = {"`bg","db","",
        "Ⴄ","LZ"};

    private static final int ITEM_CHAT = 0;
    private static final int ITEM_PHONE = 1;
    private static final int ITEM_INFO = 2;
    private static final int ITEM_REMOVE = 3;
    private static final int ITEM_CANCEL = 4;

    private static final String TITLE_INFO = "";

    private Buddy buddy;

    /**
     * RXgN^
     */
    public FriendMenu(Buddy buddy_) {
        super(PRE_TITLE+buddy_.getNickname(),ITEMS);
        buddy = buddy_;
    }

    /**
     * L[nh
     */
    protected Menu processFireKeyRelease() {
        Form form;

        switch( cursor ){
            case ITEM_CHAT:
                System.out.println("buddy:"+(buddy!=null));
                ImproveMIDlet.setCurrent(new MessagingCanvas(buddy));
                return null;
            case ITEM_PHONE:
                return new TwoChoiceMenu("db܂H",TwoChoiceMenu.MENU_PHONE,buddy);
            case ITEM_INFO:
                Item items[] = new Item[]{
                    new StringItem(": ",buddy.getAccount()),
                    new StringItem("ƯȰ: ",buddy.getNickname()),
                    new StringItem("dbԍ: ",buddy.getPhoneNumber()),
                    new StringItem("ð: ",buddy.getDescription()),
                    (buddy.getStatus() != Constants.STATUS_LOGOFF) ?
                        (Item)new ImageItem(":", buddy.getImage(false),
                                  ImageItem.LAYOUT_DEFAULT,"") :
                        (Item)new StringItem(":","")
                };
                form = new Form(TITLE_INFO,items);
                form.addCommand(okCommand);
                form.setCommandListener(this);
                ImproveMIDlet.setCurrent(form);
                return null;
            case ITEM_REMOVE:
                return new TwoChoiceMenu("܂H",TwoChoiceMenu.MENU_REMOVEBUDDY, buddy);
            //case ITEM_CANCEL:
            default:
                break;
        }

        return null;
    }

    /**
     * CommandListener
     */
    public void commandAction(Command c, Displayable d){
        if( c.equals(cancelCommand) ){
            ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
        } else if( c.equals(okCommand) ){
            switch(cursor){
                case ITEM_INFO:
                    break;
                default:
                    break;
            }
            ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
        }
    }
}