package com.s_cradle.improve.client;

import javax.microedition.lcdui.*;
import com.s_cradle.improve.Constants;


/**
 * bʂ`悷 Canvas łB 
 *
 * @author Masaru Yoshimura
 */
public class MessagingCanvas extends ImproveAbstractCanvas implements CommandListener{
    private static final int BUDDY_LOCATION_Y = TICKER_HEIGHT+6;
    private static final int MESSAGEBOX_LEFT_INTERVAL  = 5;
    private static final int MESSAGEBOX_RIGHT_INTERVAL = 5;
    private static final int MESSAGEBOX_UP_INTERVAL    = 50;
    private static final int MESSAGEBOX_DOWN_INTERVAL  = 5;
    private static final int MESSAGE_MAX = 30;
    private static final String MESSAGE_ATTACK = "U܂B";
    private static Command exitCommand   = new Command("ގ", Command.BACK, 1);
    private static Command attackCommand = new Command("U", Command.ITEM, 2);
    private static Command sendCommand   = new Command("M", Command.OK, 1);
    private static Command cancelCommand = new Command("ݾ", Command.CANCEL, 2);
    private TextBox textBox;
    private Buddy buddy;
    private MessageBox messageBox;

    /**
     * RXgN^
     */
    public MessagingCanvas(Buddy buddy_) {
        buddy = buddy_;
        messageBox = buddy.getMessageBox();
        if(messageBox == null){
            messageBox = new MessageBox(MESSAGEBOX_LEFT_INTERVAL,MESSAGEBOX_UP_INTERVAL,
                                        getWidth()-MESSAGEBOX_RIGHT_INTERVAL,
                                        getHeight()-MESSAGEBOX_DOWN_INTERVAL);
            buddy.setMessageBox(messageBox);
        }
        addCommand(exitCommand);
        addCommand(attackCommand);
        setCommandListener(this);
    }

    /**
     * commandListener
     */
    public void commandAction(Command c, Displayable d){
        if( c.equals(exitCommand) ){
            buddy.setMessageBox(null);
            ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
        } else if( c.equals(attackCommand) ){
            Task task = Task.getTask(Task.TASK_SEND,new String[]{
                                     buddy.getAccount(),
                                     String.valueOf(Constants.MESSAGE_TYPE_ATTACK),
                                     MESSAGE_ATTACK
            });
            task.schedule(0);
        } else if( c.equals(sendCommand) ){ //MTextBox
            Task task = Task.getTask(Task.TASK_SEND,new String[]{
                                     buddy.getAccount(),
                                     String.valueOf(Constants.MESSAGE_TYPE_NORMAL),
                                     textBox.getString()
            });
            task.schedule(0);
            textBox = null;
            ImproveMIDlet.setCurrent(this);
        } else if( c.equals(cancelCommand) ){ //LZ
            textBox = null;
            ImproveMIDlet.setCurrent(this);
        }
    }

    /**
     * `
     */
    public void paint(Graphics g){
        draw3DRect(g, 0, TICKER_HEIGHT+1, getWidth(), getHeight()-TICKER_HEIGHT-1,
                   LIST_BG_COLOR, 0x00EEEEFF, 0x00000080);

        ticker.paint(g);
        buddy.draw(g,getWidth(),BUDDY_LOCATION_Y,false,true);
        messageBox.draw(g);
    }

    /**
     * L[nh
     */
    protected void keyReleased(int keyCode){
        try{
            switch( getGameAction(keyCode) ){
                case FIRE:
                    textBox = new TextBox("bZ[WM","",MESSAGE_MAX,TextField.ANY);
                    textBox.addCommand(sendCommand);
                    textBox.addCommand(cancelCommand);
                    textBox.setCommandListener(this);
                    ImproveMIDlet.setCurrent(textBox);
                    break;
                case LEFT:
                    ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
                    break;
                default:
                    messageBox.processKeyRelease(getGameAction(keyCode),keyCode);
            }

            repaint();
        } catch(IllegalArgumentException ex){
            //NOP
        }
    }
}
