package com.s_cradle.improve.client;

import java.io.*;
import com.s_cradle.improve.Constants;
import java.util.*;
import javax.microedition.lcdui.Canvas;
import javax.microedition.lcdui.Displayable;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * Iy[V polling g^XNsNXłB
 *
 * @author Masaru Yoshimura
 */
public class PollingTask extends Task{
    private static final String TICKERMESSAGE_ATTACKED = "U܂I";
    private static final String MESSAGE_ATTACKED = "U܂B";

    private Vector newList;
    private Vector messages;

    private static final String[] ITEMS = new String[]{
        Constants.PARAMETER_ACCOUNT, Constants.PARAMETER_PASSWORD};

    /**
     * RXgN^B^XNŎgl(AJEg,pX[h)ɂƂB
     */
    public PollingTask(String[] strs) {
        super(TASK_POLLING,ITEMS,new String[]{account,password});
        newList = new Vector();
        messages = new Vector();
    }

    /**
     * s̏
     */
    protected void processFailed() {
    }

    /**
     * Ԓlǂ񂾌̏
     */
    protected void processAfterReturnValue(int result, DataInputStream input) throws java.io.IOException {
        Vector oldList = ImproveMIDlet.buddyList;

        short userNumber = (short)(result >> 16);
        short messageNumber = (short)result;

        for (short i=0; i<userNumber; i++) {
            if( i == 0 ){
                Buddy buddy = new Buddy(input);
                buddy.setAttribute(Buddy.ATTRIBUTE_HIM);
                newList.addElement(buddy);
            } else{
                newList.addElement(new Buddy(input));
            }
        }

        for (short i=0; i<messageNumber; i++) {
            messages.addElement(new Message(input));
        }

        ImproveMIDlet.callSerially(new Runnable(){
            public void run(){
                Vector oldList = ImproveMIDlet.buddyList;
                Vector buddyList = new Vector();
                Hashtable hush = new Hashtable();

                for(Enumeration e=newList.elements();e.hasMoreElements();){
                    Buddy newBuddy = (Buddy)e.nextElement();
                    if( oldList.indexOf(newBuddy) >= 0 ){
                        Buddy oldBuddy = (Buddy)oldList.elementAt(oldList.indexOf(newBuddy));
                        oldBuddy.update(newBuddy);
                        buddyList.addElement(oldBuddy);
                        hush.put(oldBuddy.getAccount(),oldBuddy);
                    } else{
                        buddyList.addElement(newBuddy);
                        hush.put(newBuddy.getAccount(),newBuddy);
                    }
                }

                for(Enumeration e=messages.elements();e.hasMoreElements();){
                    Message m = (Message)e.nextElement();
                    Buddy buddy = (Buddy)hush.get(m.getAccount());
                    if( m.getFrom() == m.FROM_ME){
                        if(buddy != null){
                            if(buddy.getMessageBox() == null){
                                new MessagingCanvas(buddy);
                            }
                            buddy.getMessageBox().addMessage(m.getContent(),MessageBox.MESSAGE_MINE);
                        }
                    } else if(m.getFrom() == m.FROM_OTHER){
                        if( m.getType() == Constants.MESSAGE_TYPE_NORMAL){
                            if( buddy != null){
                                if(buddy.getMessageBox() == null){
                                    new MessagingCanvas(buddy);
                                }
                                buddy.getMessageBox().addMessage(m.getContent(),MessageBox.MESSAGE_OTHER);
                            }
                        } else if(m.getType() == Constants.MESSAGE_TYPE_ATTACK){
                            ImproveMIDlet.listCanvas.ticker.insert(Ticker.LEVEL_NORMAL,m.getAccount()+TICKERMESSAGE_ATTACKED);
                            if( buddy != null){
                                if(buddy.getMessageBox() == null){
                                    new MessagingCanvas(buddy);
                                }
                                buddy.getMessageBox().addMessage(MESSAGE_ATTACKED,MessageBox.MESSAGE_OTHER);
                            }
                        }
                    }
                }

                ImproveMIDlet.buddyList = buddyList;
                Displayable d = ImproveMIDlet.getCurrent();
                if( d instanceof Canvas ){
                    ((Canvas)d).repaint();
                }
                newList = new Vector();
                messages = new Vector();
            }
        });
    }

    /**
     * ̓bZ[WǉB
     */
    public void addOwnMessage(String target,String content){
        messages.addElement(new Message(target,content));
    }
}


