package com.s_cradle.improve.client;

import com.s_cradle.improve.Constants;
import java.util.Timer;
import java.util.TimerTask;
import java.io.*;
import java.util.*;
import javax.microedition.io.*;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * Timer ATimerTask pNXłB
 *
 * @author Masaru Yoshimura
 */
public abstract class Task extends TimerTask {
    // ^XN̏
    public static final int STATUS_NOT_YET    = 0;
    public static final int STATUS_PROCESSING = 1;
    public static final int STATUS_SUCCEEDED  = 2;
    public static final int STATUS_FAILED     = 3;

    // ^XNID
    public static final int TASK_CREATE  = 0;
    public static final int TASK_DELETE  = 1;
    public static final int TASK_ADD     = 2;
    public static final int TASK_REMOVE  = 3;
    public static final int TASK_SET     = 4;
    public static final int TASK_SEND    = 5;
    public static final int TASK_POLLING = 6;
    public static final int TASK_TEST    = 7;
    public static final int TASK_CHECK   = 8;

    // |[OԊu
    public static final int POLLING_PERIOD = 5000;

    protected static String account;
    protected static String password;
    private static Timer timer = new Timer();
    private String[] operation = new String[]{
        Constants.OPERATION_CREATE,Constants.OPERATION_DELETE,
        Constants.OPERATION_ADD,Constants.OPERATION_REMOVE,
        Constants.OPERATION_SET, Constants.OPERATION_SEND,
        Constants.OPERATION_POLLING, Constants.OPERATION_TEST,
        Constants.OPERATION_CHECK
    };

    protected String[] parameterValues;
    protected String[] parameterNames;
    protected volatile int status;
    private volatile Object returnValue = null;
    protected int task;

    protected Task(){ //͎qł܂傤B
    }

    protected Task(int task, String[] names, String[] values) {
        this.task = task;
        this.parameterNames = names;
        this.parameterValues = values;
        status = STATUS_NOT_YET;

        if (names.length != values.length) {
            throw new IllegalArgumentException("number of argument names and values not match!");
        }
    }

    public static void setAccount(String account_){
        account = account_;
    }

    public static String getAccount(){
        return account;
    }

    public static void setPassword(String password_){
        password = password_;
    }

    public static String getPassword(){
        return password;
    }

    public static Task getFirstTask(){
        ResourceManager.getAccountAndPasswordFromRecordStore();

        if(account != null && account.length() != 0 &&
           password != null && password.length() != 0){
            ImproveMIDlet.setCurrent(ImproveMIDlet.listCanvas);
            Task.getTask(Task.TASK_SET,new String[]{
                    String.valueOf(Constants.ITEM_INDEX_STATUS),
                    String.valueOf(Constants.STATUS_BLUE)})
                .schedule(0);
            return getTask(TASK_POLLING,null);
        }
        else{
            TextBox textBox = new TextBox("OC","",Constants.ACCOUNT_MAX,TextField.EMAILADDR);
            textBox.addCommand(ImproveMIDlet.okCommand);
            textBox.setCommandListener(ImproveMIDlet.midlet);

            ImproveMIDlet.setCurrent(textBox);
            return null;
        }
    }

    public static Task getTask(int task, String[] str){
        switch(task){
            case TASK_CREATE:
                return new CreateTask(str);
            case TASK_DELETE:
                return new DeleteTask(str);
            case TASK_ADD:
                return new FollowedByPollingTask(FollowedByPollingTask.FBPT_ADD,str);
            case TASK_REMOVE:
                return new FollowedByPollingTask(FollowedByPollingTask.FBPT_REMOVE,str);
            case TASK_SET:
                return new FollowedByPollingTask(FollowedByPollingTask.FBPT_SET,str);
            case TASK_SEND:
                return new FollowedByPollingTask(FollowedByPollingTask.FBPT_SEND,str);
            case TASK_POLLING:
                return new PollingTask(str);
        }

        return null;
    }

    public void run(){
        try{
            System.out.println(">>run:"+task);
            HttpConnection http = null;
            DataInputStream input = null;
            int result;
            status = STATUS_PROCESSING;

            char sep = '?';
            StringBuffer buf = new StringBuffer();
            String temp = ImproveMIDlet.midlet.getAppProperty(ImproveMIDlet.ALLOW_URL);
            buf.append(temp.substring(0, temp.length()-1));
            buf.append(operation[task]);
            for (int i=0; i<parameterValues.length; i++) {
                buf.append(sep).append(parameterNames[i]).append('=').append(encode(parameterValues[i]));
                if (i==0) {
                    sep = '&';
                }
            }

            try {
                http = (HttpConnection)Connector.open(buf.toString());
                input = http.openDataInputStream();
                result = input.readInt();
                if (result > 0){
                    processAfterReturnValue(result, input);
                }
            } catch (IOException ioe) {
                ioe.printStackTrace();
                result = -1;
            }

            try {
                if (input != null) {
                    input.close();
                }
                if (http != null) {
                    http.close();
                }

            } catch (IOException ioe) {
                ioe.printStackTrace();
            }

            status = (result >=0) ? STATUS_SUCCEEDED : STATUS_FAILED;
            if(result < 0){
                processFailed();
            }

            System.out.println("<<run");
        } catch(Throwable a){
            processThrowable();
            a.printStackTrace();
        }
        return;
    }

    /**
     * URLGR[h܂BGR[hShift-JISp܂B
     *
     * @param in GR[hė~
     * @return GR[hꂽ
     */
    public static String encode(String in) {
        StringBuffer inBuf = new StringBuffer(in);;
        StringBuffer outBuf = new StringBuffer();
        for (int i=0;i<inBuf.length(); i++) {
            char temp = inBuf.charAt(i);
            if (('a'<=temp && temp <='z')
                || ('A'<=temp && temp <='Z')
                || ('0'<=temp && temp <='9')
                || temp == '.' || temp == '-' || temp == '*' || temp == '_') {
                outBuf.append(temp);
            } else if (temp == ' ') {
                outBuf.append('+');
            } else {
                byte[] bytes;
                try {
                    bytes = new String(new char[]{temp}).getBytes("SJIS");
                    for(int j=0;j<bytes.length;j++) {
                        int high = (bytes[j]>>>4)&0x0F;
                        int low  = (bytes[j]&0x0F);
                        outBuf.append('%');
                        outBuf.append(Integer.toString(high, 16).toUpperCase());
                        outBuf.append(Integer.toString(low , 16).toUpperCase());
                    }
                } catch (Exception e) {
                }
            }
        }
        return outBuf.toString();
    }

    protected void processThrowable(){
        System.out.println("Task.processThrowable");
        processFailed();
    }

    /** s̏ */
    protected abstract void processFailed();

    /** Ԓlǂ񂾌̏ */
    protected abstract void processAfterReturnValue(int result, DataInputStream input) throws IOException;

    /** Ԃl̎擾 */
    public Object getReturnValue() {
        return returnValue;
    }

    /** XPW[ */
    public void schedule(long delay) {
        timer.schedule(this, delay);
    }

    /** XPW[ */
    public void schedule(long delay, long period) {
        timer.schedule(this, delay, period);
    }

    /** ^C}̃LZ */
    public static void cancelTimer() {
        timer.cancel();
    }

    /** ^XN̏󋵂̎擾 */
    public int getProcessorStatus() {
        return status;
    }
}
