package com.s_cradle.improve.server.protocol;

import com.s_cradle.improve.*;
import com.s_cradle.improve.server.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * Iy[V polling NXłB
 *
 * @author Itaru Ogawa
 */
public class Polling extends GetOperation {

    /**
     * parameters  add vp[^[܂B
     */
     protected Polling() {
        parameters = new String[]{
            Constants.PARAMETER_ACCOUNT,
            Constants.PARAMETER_PASSWORD
        };
    }

    /**
     * GET\bhŃNGXg󂯂̏łB
     * [U[F؂ɒʂΗFBXgƃbZ[WXg𑗂܂B
     */
    public int processGet(HttpServletRequest req, HttpServletResponse res)
        throws IOException
    {
        String account = req.getParameter(Constants.PARAMETER_ACCOUNT);
        String password = req.getParameter(Constants.PARAMETER_PASSWORD);
        ImproveServlet.out.println(" account = "+account);
        ImproveServlet.out.println(" password = "+password);

        int type = -1;
        Connection con = null;
        Statement st = null;
        String sql = null;
        int userNumber = -1;
        int messageNumber = -1;
        DataOutputStream tempOut = null;
        ByteArrayOutputStream baseOut = null;
        Timestamp readTime = null;
        boolean authorized = false;

        try {
            // JDBChCõ[hƐڑ
            Class.forName(Constants.POSTGRESQL_DRIVER).newInstance();
            con = DriverManager.getConnection(Constants.POSTGRESQL_CONNECTION);
            if (isAuthorized(account, password)) {
                // FBXg̎擾
                ResultSet rs = null;
                baseOut = new ByteArrayOutputStream();
                tempOut = new DataOutputStream(baseOut);
                st = con.createStatement();
                sql = "SELECT account, nickname, phone, status, description "
                    + "FROM users "
                    + "WHERE account='"+account+"'";
                ImproveServlet.out.println(" executeUpdate : "+sql);
                rs = st.executeQuery(sql);
                ImproveServlet.out.print("  SELF : ");
                while (rs.next()) {
                    tempOut.writeUTF(rs.getString(1));
                    ImproveServlet.out.print("  account = "+rs.getString(1));
                    tempOut.writeUTF(rs.getString(2));
                    ImproveServlet.out.print("  nickname = "+rs.getString(2));
                    tempOut.writeUTF(rs.getString(3));
                    ImproveServlet.out.print("  phone = "+rs.getString(3));
                    tempOut.writeInt(rs.getInt(4));
                    ImproveServlet.out.print("  status = "+rs.getString(4));
                    tempOut.writeUTF(rs.getString(5));
                    ImproveServlet.out.println("  description = "+rs.getString(5));
                }
                st.close();

                st = con.createStatement();
                sql = "SELECT u.account, u.nickname, u.phone, u.status, u.description "
                    + "FROM users u, friends f "
                    + "WHERE f.target = u.account AND f.account = '"+account+"'"
                    + "ORDER BY u.status DESC, nickname";

                ImproveServlet.out.println(" executeUpdate : "+sql);
                rs = st.executeQuery(sql);
                int temp;

                ImproveServlet.out.println(" Friends : ");
                for (temp = 1; rs.next() && temp < Short.MAX_VALUE; temp++) {
                    tempOut.writeUTF(rs.getString(1));
                    ImproveServlet.out.print("  account = "+rs.getString(1));
                    tempOut.writeUTF(rs.getString(2));
                    ImproveServlet.out.print("  nickname = "+rs.getString(2));
                    tempOut.writeUTF(rs.getString(3));
                    ImproveServlet.out.print("  phone = "+rs.getString(3));
                    tempOut.writeInt(rs.getInt(4));
                    ImproveServlet.out.print("  status = "+rs.getString(4));
                    tempOut.writeUTF(rs.getString(5));
                    ImproveServlet.out.println("  description = "+rs.getString(5));
                }
                st.close();
                userNumber = temp;


                st = con.createStatement();
                sql = "SELECT now()";
                ImproveServlet.out.println(" executeUpdate : "+sql);
                rs = st.executeQuery(sql);
                while(rs.next()) {
                    readTime = rs.getTimestamp(1);
                }
                st.close();


                st = con.createStatement();
                sql = "SELECT account, type, content "
                    + "FROM messages "
                    + "WHERE target='"+account+"' AND  receiveTime < '"+readTime+"' "
                    + "ORDER BY receiveTime";

                ImproveServlet.out.println(" executeUpdate : "+sql);
                rs = st.executeQuery(sql);
                ImproveServlet.out.println(" Messages : ");
                for (temp = 0; rs.next() && temp < Short.MAX_VALUE; temp++) {
                    tempOut.writeUTF(rs.getString(1));
                    ImproveServlet.out.print("  account = "+rs.getString(1));
                    tempOut.writeInt(rs.getInt(2));
                    ImproveServlet.out.print("  type = "+rs.getInt(2));
                    tempOut.writeUTF(rs.getString(3));
                    ImproveServlet.out.println("  content = "+rs.getString(3));
                }
                st.close();
                messageNumber = temp;

            }

        } catch (SQLException sqle) {
            sqle.printStackTrace();
            ImproveServlet.out.println(" EXCEPTION : "+sqle);
            userNumber = -1;
            messageNumber = -1;

        } catch (IOException ioe) {
            ioe.printStackTrace();
            ImproveServlet.out.println(" EXCEPTION : "+ioe);
            userNumber = -1;
            messageNumber = -1;

        } finally {
            int ret;
            if (userNumber<0 || messageNumber <0) {
                ret = -1;
            } else {
                ret = (userNumber << 16) | messageNumber;
            }
            res.setContentType(Constants.CONTENT_TYPE_BINARY);
            DataOutputStream out = new DataOutputStream(res.getOutputStream());
            out.writeInt(ret);
            if (userNumber >=0 && messageNumber >=0) {
                byte[] buf = baseOut.toByteArray();
                out.write(buf, 0, buf.length);
                tempOut.close();
            }

            res.setContentLength(out.size());
            out.close();
            ImproveServlet.out.println(" result = "+ret);

            if (messageNumber>0 && readTime != null) {
                try {
                    sql = "DELETE FROM messages "
                        + "WHERE target = '"+account+"' AND receiveTime < '"+readTime+"'";
                    st.executeUpdate (sql);
                    ImproveServlet.out.println(" executeUpdate : "+sql);
                } catch (SQLException sqle2) {
                    sqle2.printStackTrace();
                    ImproveServlet.out.println(" EXCEPTION : "+sqle2);
                }
            }

            try {
                if (st!=null) {
                    st.close();
                }
                if (con!=null) {
                    con.close();
                }
            } catch (SQLException sqle3) {
                sqle3.printStackTrace();
                ImproveServlet.out.println(" EXCEPTION : "+sqle3);
            }

            return ret;
        }
    }
}
