package com.s_cradle.improve.server.protocol;

import com.s_cradle.improve.*;
import com.s_cradle.improve.server.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.sql.*;

/**
 * Copyright (C) 2003 Sophia Cradle, Inc.
 *
 * Iy[V set NXłB
 *
 * @author Itaru Ogawa
 */
public class Set extends GetOperation {

    /**
     * parameters  set vp[^[܂B
     */
    protected Set() {
        parameters = new String[]{
            Constants.PARAMETER_ACCOUNT,
            Constants.PARAMETER_PASSWORD,
            Constants.PARAMETER_ITEM,
            Constants.PARAMETER_CONTENT
        };
    }

    /**
     * GET\bhŃNGXg󂯂̏łB
     * [U[F؂ɒʂΎ̏ݒ肵܂B
     */
    public int processGet(HttpServletRequest req, HttpServletResponse res)
        throws IOException
    {
        String account = req.getParameter(Constants.PARAMETER_ACCOUNT);
        String password = req.getParameter(Constants.PARAMETER_PASSWORD);
        String itemString = req.getParameter(Constants.PARAMETER_ITEM);
        String content = req.getParameter(Constants.PARAMETER_CONTENT);
        String sql;
        int item = -1;
        int ret = -1;

        ImproveServlet.out.println(" account = "+account);
        ImproveServlet.out.println(" password = "+password);
        ImproveServlet.out.println(" item = "+itemString);
        ImproveServlet.out.println(" content = "+content);

        try {
            item = Integer.parseInt(itemString);
            switch (item) {
            case Constants.ITEM_INDEX_NICKNAME:
            case Constants.ITEM_INDEX_PHONE:
            case Constants.ITEM_INDEX_DESCRIPTION:
            case Constants.ITEM_INDEX_STATUS:
                break;

            case Constants.ITEM_INDEX_ACCOUNT:
            case Constants.ITEM_INDEX_PASSWORD:
            default:
                item = -1;
                break;
            }
        } catch (NumberFormatException nfe) {
            nfe.printStackTrace();
            ImproveServlet.out.println(" EXCEPTION : "+nfe);
        }

        Connection con = null;
        Statement st = null;

        try {
            if (item != -1) {
                // JDBChCõ[hƐڑ
                Class.forName(Constants.POSTGRESQL_DRIVER).newInstance();
                con = DriverManager.getConnection(Constants.POSTGRESQL_CONNECTION);

                if (isAuthorized(account, password)) {// Fؐ
                    st = con.createStatement();
                    sql = "UPDATE users "
                        + "SET "+Constants.ITEM_COLUMN_NAME[item]+" = '"+content+"' "
                        + "WHERE account = '"+account+"'";
                    ImproveServlet.out.println(" executeUpdate : "+sql);
                    st.executeUpdate (sql);
                    st.close();

                    ret = content.length();
                }
                con.close();
                st = null;
                con = null;
            }

        } catch (SQLException sqle) {
            sqle.printStackTrace();
            ImproveServlet.out.println(" EXCEPTION : "+sqle);
            ret = -1;

        } finally {
            try {
                if (st!=null) {
                    st.close();
                }
                if (con!=null) {
                    con.close();
                }
            } catch (SQLException sqle2) {
                sqle2.printStackTrace();
                ImproveServlet.out.println(" EXCEPTION : "+sqle2);
            }

            res.setContentType(Constants.CONTENT_TYPE_BINARY);
            DataOutputStream out = new DataOutputStream(res.getOutputStream());
            out.writeInt(ret);
            res.setContentLength(out.size());
            out.close();
            ImproveServlet.out.println(" result = "+ret);
            return ret;
        }
    }
}
